
    <!DOCTYPE html>
    <html>
      <head>
        <meta charset="utf-8">
      </head>
      <body>

        <div class="marpit"><svg data-marpit-svg="" viewBox="0 0 1280 5000"><foreignObject width="1280" height="5000"><section id="1" data-marpit-fragments="17">
<h1>Сессии</h1>
<p>Сессия — это абстракция, созданная для удобной работы с индивидуальными пользователями. Этот механизм позволяет хранить информацию между разными запросами одного и того же пользователя. Он используется для идентификации пользователей и позволяет отличать их друг от друга. Например, аутентификация на сайтах построена поверх механизма сессии. В этом домашнем задании вам предстоит реализовать аутентификацию ()пользователей на сайте и вывод flash-сообщений. Flash — это одноразовое сообщение о результатах выполнения любого действия. Оно обычно используется после перенаправления для индикации успешности или неудачи предыдущего действия. Flash-сообщения для своей работы также используют механизм сессий. Аутентификация — это процедура проверки подлинности пользователя, например путем сравнения введённого им пароля с паролем, сохранённым в базе данных пользователей.</p>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="1"><a href="https://javaee.github.io/javaee-spec/javadocs/javax/servlet/http/HttpSession.html">Интерфейс HttpSession</a></li>
<li data-marpit-fragment="2"><a href="https://javaee.github.io/javaee-spec/javadocs/javax/servlet/http/HttpServletRequest.html#getSession--">Получение сессии — метод getSession()</a></li>
<li data-marpit-fragment="3"><a href="https://javaee.github.io/javaee-spec/javadocs/javax/servlet/http/HttpSession.html#setAttribute-java.lang.String-java.lang.Object-">Добавление атрибута в сессию — метод setAttribute()</a></li>
<li data-marpit-fragment="4"><a href="https://javaee.github.io/javaee-spec/javadocs/javax/servlet/http/HttpSession.html#removeAttribute-java.lang.String-">Удаление атрибута из сессии — метод removeAttribute()</a></li>
<li data-marpit-fragment="5"><a href="https://ru.hexlet.io/courses/html/lessons/devtools/theory_unit">Панель разработчика</a></li>
</ul>
<h2>Users.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="6">Изучите класс <code>Users</code> и его методы. Этот класс предоставляет методы для работы со списком пользователей, они понадобятся вам для реализации аутентификации.</li>
</ul>
<h2>App.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="7">Назначьте сервлет <code>SessionServlet</code> как обработчик запросов по двум адресам: <em>/login</em> и <em>/logout</em></li>
</ul>
<h2>servlet/SessionServlet.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="8">
<p>Изучите содержимое методов <code>doGet()</code> и <code>doPost()</code>. Обратите внимание, как организована обработка сервлетом запросов по нескольким адресам и при помощи какого метода происходит получение части URL.</p>
</li>
<li data-marpit-fragment="9">
<p>Допишите метод <code>login()</code>, который обрабатывает POST-запросы по пути <em>/login</em>. В методе реализуйте аутентификацию пользователя в системе. Для того, чтобы данные пользователя сохранялись между запросами, вам потребуется использовать сессию. Аутентификация производится по email пользователя и паролю. Для простоты пароль для всех пользователей одинаковый — &quot;password&quot;. Если пользователь существует и введен верный пароль, установите в сессию атрибуты &quot;userId&quot; со значением id пользователя и &quot;flash&quot; со значением &quot;Вы успешно вошли&quot;, затем выполните редирект на главную страницу <em>/</em>. Таким образом данные пользователя будут сохранены в сессии и мы сможем определить, что данный пользователь вошел в систему. Атрибут &quot;flash&quot; будет использоваться для вывода flash-сообщения.</p>
<p>Если пользователь не существует в системе или пароль введен неверно, установите в сессию атрибут &quot;flash&quot; со значением &quot;Неверные логин или пароль&quot;, установите код ответа 422 и передайте управление в файл <em>/login.jsp</em>. При ошибке входа поле формы email должно быть заполнено введенными данными.</p>
</li>
<li data-marpit-fragment="10">
<p>Допишите метод <code>logout()</code>, который обрабатывает POST-запросы по пути <em>/logout</em>. В методе реализуйте выход пользователя из системы. Чтобы вывести пользователя из системы, нужно удалить из сессии его данные. После вывода пользователя из системы установите в сессию  атрибут &quot;flash&quot; со значением &quot;Вы успешно вышли&quot; и выполните редирект на главную страницу <em>/</em>.</p>
</li>
</ul>
<h2>webapp/WEB-INF/application.tag</h2>
<p>В прошлом домашнем задании мы создали несколько шаблонов для работы с пользователями. Вы наверняка обратили внимание, что есть одинаковая общая часть, которая повторяется в каждом шаблоне. Чтобы не копировать эту общую часть в каждый шаблон, её можно вынести в отдельный файл, а в jsp-файлах разместить только переменную часть, уникальную для каждого шаблона.</p>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="11">
<p>Изучите содержимое файла <em>webapp/WEB-INF/application.tag</em>. Обратите внимание на то, как происходит работа с сессией.</p>
</li>
<li data-marpit-fragment="12">
<p>Организуйте вывод flash-сообщения. Чтобы добавить красоты, используйте классы Bootstrap</p>
<pre><code class="language-html"><span class="hljs-tag">&lt;<span class="hljs-name">div</span> <span class="hljs-attr">class</span>=<span class="hljs-string">&quot;alert alert-info&quot;</span> <span class="hljs-attr">role</span>=<span class="hljs-string">&quot;alert&quot;</span>&gt;</span>
    Сообщение
<span class="hljs-tag">&lt;/<span class="hljs-name">div</span>&gt;</span>
</code></pre>
<p>Так как flash-сообщение должно выводиться только один раз, после вывода его нужно удалить.</p>
</li>
</ul>
<p>Работа сессий основана на механизме куки. Старт сессии на техническом уровне означает установку специальной куки в браузер. Эта кука содержит идентификатор сессии, который уникален для каждого пользователя. Запустите приложение и откройте его в браузере. Выполните аутентификацию пользователя в системе. Откройте панель разработчика на вкладке Application - Cookies и посмотрите установленные куки.</p>
<h2>Самостоятельная работа</h2>
<ul>
<li data-marpit-fragment="13">В итоге у вас получится красивое приложение, которое вы можете показать друзьям. Выполните деплой приложения на heroku и оно станет доступно в интернете. Для этого вам нужно будет вспомнить все аспекты урока &quot;Деплой&quot;.</li>
</ul>
<h2>Подсказки</h2>
<ul>
<li data-marpit-fragment="14">Изучите файл example.java</li>
<li data-marpit-fragment="15">Атрибуты сессии внутри файла <em>tag</em> доступны в контексте <code>sessionScope</code>. Для доступа к атрибутам сессии используйте синтаксис <code>sessionScope.attributeName</code>.</li>
<li data-marpit-fragment="16">Сама сессия доступна внутри внутри файла <em>tag</em> в переменной <code>session</code></li>
<li data-marpit-fragment="17">В tag и jsp-файлах можно использовать java-код, разместив его между тегами <code>&lt;% %&gt;</code></li>
</ul>
</section>
<script>!function(){"use strict";const t="marpitSVGPolyfill:setZoomFactor,",e=Symbol();let r,o;function n(n){const i="object"==typeof n&&n.target||document,a="object"==typeof n?n.zoom:n;window[e]||(Object.defineProperty(window,e,{configurable:!0,value:!0}),window.addEventListener("message",(({data:e,origin:r})=>{if(r===window.origin)try{if(e&&"string"==typeof e&&e.startsWith(t)){const[,t]=e.split(","),r=Number.parseFloat(t);Number.isNaN(r)||(o=r)}}catch(t){console.error(t)}})));let l=!1;Array.from(i.querySelectorAll("svg[data-marpit-svg]"),(t=>{var e,n,i,s;t.style.transform||(t.style.transform="translateZ(0)");const c=a||o||t.currentScale||1;r!==c&&(r=c,l=c);const d=t.getBoundingClientRect(),{length:u}=t.children;for(let r=0;r<u;r+=1){const o=t.children[r],a=o.getScreenCTM();if(a){const t=null!==(n=null===(e=o.x)||void 0===e?void 0:e.baseVal.value)&&void 0!==n?n:0,r=null!==(s=null===(i=o.y)||void 0===i?void 0:i.baseVal.value)&&void 0!==s?s:0,l=o.firstElementChild,{style:u}=l;u.transformOrigin||(u.transformOrigin=`${-t}px ${-r}px`),u.transform=`scale(${c}) matrix(${a.a}, ${a.b}, ${a.c}, ${a.d}, ${a.e-d.left}, ${a.f-d.top}) translateZ(0.0001px)`}}})),!1!==l&&Array.from(i.querySelectorAll("iframe"),(({contentWindow:e})=>{null==e||e.postMessage(`${t}${l}`,"null"===window.origin?"*":window.origin)}))}r=1,o=void 0;const i=(t,e,r)=>{if(t.getAttribute(e)!==r)return t.setAttribute(e,r),!0};function a({once:t=!1,target:e=document}={}){const r="Apple Computer, Inc."===navigator.vendor?[n]:[];let o=!t;const a=()=>{for(const t of r)t({target:e});!function(t=document){Array.from(t.querySelectorAll('svg[data-marp-fitting="svg"]'),(t=>{var e;const r=t.firstChild,o=r.firstChild,{scrollWidth:n,scrollHeight:a}=o;let l,s=1;if(t.hasAttribute("data-marp-fitting-code")&&(l=null===(e=t.parentElement)||void 0===e?void 0:e.parentElement),t.hasAttribute("data-marp-fitting-math")&&(l=t.parentElement),l){const t=getComputedStyle(l),e=Math.ceil(l.clientWidth-parseFloat(t.paddingLeft||"0")-parseFloat(t.paddingRight||"0"));e&&(s=e)}const c=Math.max(n,s),d=Math.max(a,1),u=`0 0 ${c} ${d}`;i(r,"width",`${c}`),i(r,"height",`${d}`),i(t,"preserveAspectRatio",getComputedStyle(t).getPropertyValue("--preserve-aspect-ratio")||"xMinYMin meet"),i(t,"viewBox",u)&&t.classList.toggle("__reflow__")}))}(e),o&&window.requestAnimationFrame(a)};return a(),()=>{o=!1}}const l=Symbol(),s=document.currentScript;((t=document)=>{if("undefined"==typeof window)throw new Error("Marp Core's browser script is valid only in browser context.");if(t[l])return t[l];const e=a({target:t}),r=()=>{e(),delete t[l]};Object.defineProperty(t,l,{configurable:!0,value:r})})(s?s.getRootNode():document)}();
</script></foreignObject></svg></div>
      </body>
    </html>
  
